import mx.central.Shell;
import mx.central.RegExp;
import mx.controls.TextArea;

class FindReplace implements mx.central.Application {
	/**********************************************
	 *            Central functions                *
 	 ***********************************************/

    var source_txt:TextArea;
    var fileDisplay_txt:TextArea;

    var loadedFile:FileReference;
    
    var shell:Shell;
    
    function FindReplace(source:TextArea, fileDisplay:TextArea) {
        this.source_txt = source;
        this.fileDisplay_txt = fileDisplay;
    }
    
    // Called by Central once your application has loaded.
	function onActivate (shell:Shell, appID:Number, shellID:Number,
                         baseTabindex:Number, initiaData:Object):Void
    {
        this.shell = shell;

        //Some text to do search and replace on. 
        source_txt.text = "Applications are increasingly a multi-user experience. They are beginning " + 
        "to represent the presence of other people on the Internet, just starting to " +
        "support collaborative work. Applications should have a common way of integrating " +
        "communication with others in the context of the application, and be able to share " +
        "application functionality to enable live collaboration in their use. The Internet is " +
        "not only about connected web pages, it’s about connected people."
    }


    // Called by Central when the application is about to be unloaded / closed.
	function onDeactivate (Void):Void
    {
        //add clean up code here (such as closing network connections, delete variables
        //place in _global)
    }


        // Called when the application is resized. The application should resize
        // itself accordingly
	function onResize (Void):Void
    {
        var bounds = this.shell.getBounds();
    }


    // called by Central to determine the Minimum size your application can be resized to.
    // If there is no need to specify a  minimum size, you can remove this method.
	function getMinimumSize (Void):Object
    {
        // set the properties below to your Maximum size.
        return {width:200, height:200};
    }

    // search and replace function
    function PerformFindAndReplace(findstr:String, replacestr:String) {
        // this is the regular expression we will search on. It is made up
        // of a search string and the regular expression word boundary
        // symbol "\b" (note: you always need to use two escape characters
        // in your regular expression because of the way ActionScript
        // handles strings). This is so that a word like "the" will not
        // match on "other" or "these".
        shell.setStatus("Replacing '" + findstr + "' with '" + replacestr + "'");
        var find:String = "\\b" + findstr + "\\b";
    
        //this is the text we will do search and replace on 
        var source:String = source_txt.text;
    
        // we use the String object's built in replace function, passing in
        // our regular expression and the string that will replace what
        // the expression matches on
        source_txt.text = source.replace(find, replacestr);
    }

    function LoadFile(Void):Void
    {
        var fileRef = new FileReference();
        if (!fileRef.browse(["Text Files", "*.txt", "All Files", "*.*"]))
            return;
        
        source_txt.text = fileRef.readFile();

        loadedFile = fileRef;
        _root.filename_txt.text = loadedFile.name;
    }

    function SaveFile(bNewName:Boolean):Void
    {
        // in order to save the file, we need to do the writing
        // while the file is in the local internet cache
        var tmpFile = new FileReference;
        var filename = loadedFile.name;
        if (!filename)
            filename = "output.txt";

        tmpFile.create(filename);
        tmpFile.writeString(source_txt.text);
        if (bNewName)
            tmpFile.saveAs();
        else
            tmpFile.saveAs(loadedFile);
    }

    
    // Called by Central when the application is about to be un-installed
	function onUninstall (Void):Void {}
	function onNoticeEvent (event:Object, noticeData:Object, initalData:Object):Void {}
	function onNetworkChange (connected:Boolean):Void {}
	function onPaymentResult (result:Boolean, transactionID:Object):Void {}
	function onSelectedItem (data:Array):Void {}
	function showPreferences (Void):Void {}
}
